
/* ============================================================================
   A. Veneziani - Programma che implementa un generatore di scritte scorrevoli
                  con oggetti

                  Scritto in C++ Builder 6
   ============================================================================ */

#include <iostream>
#include <string>

using namespace std;

// definisce una classe  che implementa la scritta
// rotante e la sua gestione
class Scritta_rotante  {

   private:

   // indica i punti di inizio e di fine
   // nella visualizzazione della scritta
   int inizio;
   int fine;
   // stringa contente la scritta da far scorrere
   string scritta;

   // visualizzazione parziale della scritta
   // in base alle posizioni indicate i e f
   void mostra_scritta(int i, int f)
   {
        system("CLS");     // pulisce lo schermo evitando l'accumulo di scritte

        // stampa della scritta nei vari casi
        if (i < f)
           cout << scritta.substr(i, f - i);
        else
           cout << scritta.substr(i,scritta.length() - i) + scritta.substr(0,f);

   }

   public:

   // assegnazione della scritta da far scorrere
   void indica_scritta(string s)
   {
       scritta = s;
   }

   // metodo che implementa lo scorrimento controllato
   // in avanti della visualizzazione grazie alla
   // contemporanea modifica degli indici inizio e fine
   void scorri_avanti()
   {
       // chiama il metodo protetto di stampa
       // della scritta per la sottoparte indicata
       // dagli indici inizio e fine
       mostra_scritta(inizio, fine);

       // riposizionamento di inizio e fine
       inizio++;
       fine++;

       // gestione del fine linea dei cursori inizio e fine
       if (fine > scritta.length())  fine = 0;
       if (inizio > scritta.length()) inizio = 0;
   }

   // costruttore della classe - inizializza alcuni valori
   Scritta_rotante()
   {
       inizio = 0;
       fine = 15;
       // pone a rosso il colore delle scritte che appaiono
       // sullo schermo (per maggior realismo)
       system("COLOR C");
   }

};

void main()
{
    Scritta_rotante sr;

    // asegna una stringa all' apposito campo della classe
    sr.indica_scritta("      Questa e' una scritta per test sulle scritte rotanti.");

    // ciclo infinito
    while (true)
    {
        // impone una pausa al programma di 200 millisecondi
        Sleep(200);
        // comanda un avanzamento
        sr.scorri_avanti();
    }

}
